package Utils;

import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;

import javax.swing.JCheckBox;

import ganes.ManejoIdiomas;

public class ProductoUtils {

	public ProductoUtils() {
		super();
	}

	public static void activarDesactivarCheckSegunProducto(String comboProductosSelected, JCheckBox checkModalidadClicked, Boolean chekcModalidadClickedValue, JCheckBox[] modalidadesIncluidasCheckBox) {

		String[] modalidades = getModalidadesDescripcionArray();
		String[] productos = getProductosArrayParaModalidades();
		String[] checksToToggleA = {};
		String[] checksToToggleB = {};

		if (productos[ConstantesTextos.PROD_NOTIFICACIONES_JD_DE_ACUERDOS_ESPECIALES].toString().equals(comboProductosSelected) ) {
			Map<String,JCheckBox> mapaModalidadesIncluidasCheckBox = getMapaModalidades(modalidadesIncluidasCheckBox);
			checksToToggleA = new String[]{"1","2"};//Clasificacin de Envios y Digitalizacion
			checksToToggleB = new String[]{modalidades[ConstantesTextos.MOD_PRUEBA_ENTREGA_ELECT].toString()};//PEE
			//Se ha clicado en el primer grupo, invertimos Enabled true/false en el segundo
			if (Arrays.asList(checksToToggleB).contains(checkModalidadClicked.getText().replace("--", ""))) {
				mapaModalidadesIncluidasCheckBox.get(checksToToggleA[0]).setEnabled(true);
				mapaModalidadesIncluidasCheckBox.get(checksToToggleA[1]).setEnabled(true);
				if (chekcModalidadClickedValue ) {
					mapaModalidadesIncluidasCheckBox.get(checksToToggleA[0]).setSelected(false);
					mapaModalidadesIncluidasCheckBox.get(checksToToggleA[0]).setEnabled(false);
					mapaModalidadesIncluidasCheckBox.get(checksToToggleA[1]).setSelected(false);
					mapaModalidadesIncluidasCheckBox.get(checksToToggleA[1]).setEnabled(false);
				}
			//Se ha clicado en el segundo grupo, invertimos Enabled true/false en el segundo
			}else if (Arrays.asList(checksToToggleA).contains(checkModalidadClicked.getActionCommand() )) {
				if (!mapaModalidadesIncluidasCheckBox.get(checksToToggleA[0]).isSelected()
					&& !mapaModalidadesIncluidasCheckBox.get(checksToToggleA[1]).isSelected()) {
					mapaModalidadesIncluidasCheckBox.get(checksToToggleB[0]).setEnabled(true);
				}else {
					mapaModalidadesIncluidasCheckBox.get(checksToToggleB[0]).setEnabled(false);
					mapaModalidadesIncluidasCheckBox.get(checksToToggleB[0]).setSelected(false);
				}

			}
		}

//		comboProducto.equals(productos[ConstantesTextos.PROD_NOTIFICACIONES_JD_DE_ACUERDOS_ESPECIALES].toString())
//		&& selected

	}

	private static Map<String,JCheckBox> getMapaModalidades(JCheckBox[] modalidadesIncluidasCheckBox) {
		Map<String,JCheckBox> mapaChecks = new HashMap<String,JCheckBox>();
		for(JCheckBox check : modalidadesIncluidasCheckBox) {
			mapaChecks.put(check.getActionCommand().replace("--", ""),check);
		}
		return mapaChecks;
	}



	public static String[] getProductosArrayParaModalidades() {
		String [] productos = new String[7];
		productos[ConstantesTextos.PROD_CARTAS_CERTIFICADAS_ACUERDOS_ESPECIALES] =  ManejoIdiomas.getTextos(ConstantesTextos.TIPO_PRODUCTO, ConstantesTextos.PROD_CARTAS_CERTIFICADAS_ACUERDOS_ESPECIALES);
		productos[ConstantesTextos.PROD_NOTIFICACIONES_PROCEDIMIENTO_GENERAL] =  ManejoIdiomas.getTextos(ConstantesTextos.TIPO_PRODUCTO, ConstantesTextos.PROD_NOTIFICACIONES_PROCEDIMIENTO_GENERAL);
		productos[ConstantesTextos.PROD_NOTIFICACIONES_ACUERDOS_ESPECIALES_PEE] =  ManejoIdiomas.getTextos(ConstantesTextos.TIPO_PRODUCTO, ConstantesTextos.PROD_NOTIFICACIONES_ACUERDOS_ESPECIALES_PEE);
		productos[ConstantesTextos.PROD_NOTIFICACIONES_ACUERDOS_ESPECIALES] =  ManejoIdiomas.getTextos(ConstantesTextos.TIPO_PRODUCTO, ConstantesTextos.PROD_NOTIFICACIONES_ACUERDOS_ESPECIALES);
		productos[ConstantesTextos.PROD_CARTAS_CERTIFICADAS_ACUERDOS_ESPECIALES_PEE] =  ManejoIdiomas.getTextos(ConstantesTextos.TIPO_PRODUCTO, ConstantesTextos.PROD_CARTAS_CERTIFICADAS_ACUERDOS_ESPECIALES_PEE);
		productos[ConstantesTextos.PROD_NOTIFICACIONES_JD_DE_ACUERDOS_ESPECIALES] =  ManejoIdiomas.getTextos(ConstantesTextos.TIPO_PRODUCTO, ConstantesTextos.PROD_NOTIFICACIONES_JD_DE_ACUERDOS_ESPECIALES);
		productos[ConstantesTextos.PROD_NOTIFICACIONES_JD_DE_PROCEDIMIENTO_GENERAL] =  ManejoIdiomas.getTextos(ConstantesTextos.TIPO_PRODUCTO, ConstantesTextos.PROD_NOTIFICACIONES_JD_DE_PROCEDIMIENTO_GENERAL);
		return productos;
	}

	public static String[] getModalidadesDescripcionArray() {
		String [] modalidades = new String [4];
		modalidades[ConstantesTextos.MOD_PRUEBA_ENTREGA_ELECT] =  ManejoIdiomas.getTextos(ConstantesTextos.TIPO_MODALIDAD, ConstantesTextos.MOD_PRUEBA_ENTREGA_ELECT);
		modalidades[ConstantesTextos.MOD_E_AR] =  ManejoIdiomas.getTextos(ConstantesTextos.TIPO_MODALIDAD, ConstantesTextos.MOD_E_AR);
		modalidades[ConstantesTextos.MOD_AVISO_RECIBO] =  ManejoIdiomas.getTextos(ConstantesTextos.TIPO_MODALIDAD, ConstantesTextos.MOD_AVISO_RECIBO);
		modalidades[ConstantesTextos.MOD_SEGUIMIENTO] =  ManejoIdiomas.getTextos(ConstantesTextos.TIPO_MODALIDAD, ConstantesTextos.MOD_SEGUIMIENTO);
		return modalidades;
	}



}


